Summary: Bochs Project x86 PC Emulator
Name: bochs
Version: 2.4.6
Release: 1
License: LGPL
Group: Applications/Emulators
URL: http://bochs.sourceforge.net
Packager: Michael Perzl <michael@perzl.org>
Source0: %{name}-%{version}.tar.gz
Patch0: %{name}-%{version}-aix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires: make
BuildRequires: SDL-devel >= 1.2.14-2
BuildRequires: libXpm-devel >= 3.5.7-3
BuildRequires: libXrandr-devel >= 1.1.2-1
BuildRequires: glib2-devel >= 2.22.4
BuildRequires: gtk2-devel >= 2.18.5
BuildRequires: readline-devel >= 5.2-3

Requires: SDL >= 1.2.14-2
Requires: libXpm >= 3.5.7-3
Requires: libXrandr >= 1.1.2-1

%description
Bochs is a highly portable open source IA-32 (x86) PC emulator written
in C++, that runs on most popular platforms. It includes emulation of
the Intel x86 CPU, common I/O devices, and a custom BIOS. Currently,
Bochs can be compiled to emulate a 386, 486, Pentium, Pentium Pro or
AMD64 CPU, including optional MMX, SSEx and 3DNow! instructions.
Bochs is capable of running most Operating Systems inside the emulation
including Linux, DOS, Windows 9X/NT/2000/XP or Windows 7.


%package        debugger
Summary:        Bochs with builtin debugger
Group:          Applications/Emulators
Requires:       %{name} = %{version}-%{release}
Requires:       glib2 >= 2.22.4
Requires:       gtk2 >= 2.18.5
Requires:       readline >= 5.2-3

%description    debugger
Special version of bochs compiled with the builtin debugger.


%package        gdb
Summary:        Bochs with support for debugging with gdb
Group:          Applications/Emulators
Requires:       %{name} = %{version}-%{release}

%description    gdb
Special version of bochs compiled with a gdb stub so that the software running
inside the emulator can be debugged with gdb.


%prep
%setup -q
%patch0


%build
export CC="xlc_r -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"
export CXX="xlC_r -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"

CONFIGURE_FLAGS=" \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-a20-pin \
    --enable-x86-64 \
    --enable-cpu-level=6 \
    --enable-ne2000 \
    --enable-acpi \
    --enable-pci \
    --enable-usb \
    --enable-usb-ohci \
    --enable-repeat-speedups \
    --enable-show-ips \
    --enable-all-optimizations \
    --enable-vbe \
    --enable-clgd54xx \
    --enable-cdrom \
    --enable-sb16=dummy \
    --enable-xpm \
    --with-x \
    --with-x11 \
    --with-nogui \
    --without-term \
    --with-rfb \
    --with-sdl \
    --without-wx"

./configure ${CONFIGURE_FLAGS} --enable-x86-debugger --enable-debugger
gmake %{?_smp_mflags}
mv %{name} %{name}-debugger
gmake dist-clean

./configure ${CONFIGURE_FLAGS} --enable-x86-debugger --enable-gdb-stub
gmake %{?_smp_mflags}
mv %{name} %{name}-gdb
gmake dist-clean

./configure ${CONFIGURE_FLAGS}
gmake %{?_smp_mflags}


%install
export PATH=/opt/freeware/bin:$PATH

[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

cp %{name}-debugger %{name}-gdb ${RPM_BUILD_ROOT}%{_bindir}
chmod 0755 ${RPM_BUILD_ROOT}%{_bindir}/*

/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :

gunzip ${RPM_BUILD_ROOT}%{_mandir}/man1/*.gz
gunzip ${RPM_BUILD_ROOT}%{_mandir}/man5/*.gz

cd ${RPM_BUILD_ROOT}
mkdir -p usr/bin
cd usr/bin
ln -s ../..%{_bindir}/* .


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc CHANGES COPYING README TODO
%{_bindir}/%{name}
%{_bindir}/bxcommit
%{_bindir}/bximage
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_datadir}/%{name}
/usr/bin/%{name}
/usr/bin/bxcommit
/usr/bin/bximage


%files debugger
%defattr(-,root,system,-)
%{_bindir}/%{name}-debugger
/usr/bin/%{name}-debugger


%files gdb
%defattr(-,root,system,-)
%{_bindir}/%{name}-gdb
/usr/bin/%{name}-gdb


%changelog
* Thu Oct 06 2011 Michael Perzl <michael@perzl.org> - 2.4.6-1
- updated to version 2.4.6

* Fri May 28 2010 Michael Perzl <michael@perzl.org> - 2.4.5-1
- first version for AIX V5.1 and higher
